<?
if (!class_exists('Are_PayPal_Install')) {
	class Are_PayPal_Install{

		var $prefix;

		var $paied_users_table;
		var $paied_items_table;
		var $bonus_posts_table;
		var $paypal_payment_info_table;
		var $paypal_requests_table;
		var $paypal_field_types_table;
		var $paypal_fields_table;
		var $paypal_subscription_info_table;

		function Are_PayPal_Install(){
			global $wpdb;
			//$wpdb->show_errors();
			$configuration= new  Are_PayPal_Configuration();

			//Initialize properties
			$this->prefix=$configuration->prefix;
			$this->start_delimiter=$configuration->start_delimiter;
			$this->end_delimiter=$configuration->end_delimiter;
			$this->paied_users_table = $configuration->paied_users_table;
			$this->paied_items_table = $configuration->paied_items_table;
			$this->bonus_posts_table = $configuration->bonus_posts_table;
			$this->paypal_requests_table = $configuration->paypal_requests_table;
			$this->paypal_field_types_table = $configuration->paypal_field_types_table;
			$this->paypal_fields_table = $configuration->paypal_fields_table;
			$this->paypal_subscription_info_table = $configuration->paypal_subscription_info_table;
			$this->paypal_payment_info_table=$configuration->paypal_payment_info_table;
			
		}

		function install(){
			global $wpdb;
			$sql = "
CREATE TABLE $this->paypal_fields_table (
  `RequestID` bigint(20) NOT NULL,
  `Name` varchar(255) character set utf8 collate utf8_unicode_ci NOT NULL,
  `Value` varchar(255) character set utf8 collate utf8_unicode_ci default NULL
);

CREATE TABLE $this->paypal_field_types_table (
  `FieldTypeName` varchar(255) NOT NULL
);


CREATE TABLE $this->paypal_requests_table (
  `RequestID` bigint(20) NOT NULL auto_increment,
  `When` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`RequestID`)
);

CREATE TABLE $this->bonus_posts_table (
  `post1_id` bigint(20) NOT NULL,
  `post2_id` bigint(20) NOT NULL,
  PRIMARY KEY  (`post1_id`,`post2_id`)
);

CREATE TABLE $this->paied_items_table (
  `id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL,
  `name` varchar(255) NOT NULL,
  `number` varchar(255) default NULL,
  `amount` double NOT NULL,
  `currency` char(3) NOT NULL,
  `expire` bigint(20) default NULL,
  UNIQUE KEY `id` (`id`)
);

CREATE TABLE $this->paypal_payment_info_table (
  `FIRSTNAME` varchar(100) NOT NULL default '',
  `LASTNAME` varchar(100) NOT NULL default '',
  `BUYER_EMAIL` varchar(100) NOT NULL default '',
  `STREET` varchar(100) NOT NULL default '',
  `CITY` varchar(50) NOT NULL default '',
  `STATE` char(3) NOT NULL default '',
  `ZIPCODE` varchar(11) NOT NULL default '',
  `MEMO` varchar(255) default NULL,
  `ITEMNAME` varchar(255) default NULL,
  `ITEMNUMBER` varchar(50) default NULL,
  `OS0` varchar(20) default NULL,
  `ON0` varchar(50) default NULL,
  `OS1` varchar(20) default NULL,
  `ON1` varchar(50) default NULL,
  `QUANTITY` char(3) default NULL,
  `PAYMENTDATE` varchar(50) NOT NULL default '',
  `PAYMENTTYPE` varchar(10) NOT NULL default '',
  `TXNID` varchar(30) NOT NULL default '',
  `MC_GROSS` varchar(6) NOT NULL default '',
  `MC_FEE` varchar(5) NOT NULL default '',
  `PAYMENTSTATUS` varchar(15) NOT NULL default '',
  `PENDINGREASON` varchar(10) default NULL,
  `TXNTYPE` varchar(10) NOT NULL default '',
  `TAX` varchar(10) default NULL,
  `MC_CURRENCY` varchar(5) NOT NULL default '',
  `REASONCODE` varchar(20) NOT NULL default '',
  `CUSTOM` varchar(255) NOT NULL default '',
  `COUNTRY` varchar(20) NOT NULL default '',
  `DATECREATION` date NOT NULL default '0000-00-00'
);


CREATE TABLE $this->paied_users_table (
  `id` bigint(20) NOT NULL auto_increment,
  `post_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `expire` bigint(20) default NULL,
  `purchase_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  UNIQUE KEY `id` (`id`)
);

CREATE TABLE $this->paypal_subscription_info_table(
  `subscr_id` varchar(255) NOT NULL default '',
  `sub_event` varchar(50) NOT NULL default '',
  `subscr_date` varchar(255) NOT NULL default '',
  `subscr_effective` varchar(255) NOT NULL default '',
  `period1` varchar(255) NOT NULL default '',
  `period2` varchar(255) NOT NULL default '',
  `period3` varchar(255) NOT NULL default '',
  `amount1` varchar(255) NOT NULL default '',
  `amount2` varchar(255) NOT NULL default '',
  `amount3` varchar(255) NOT NULL default '',
  `mc_amount1` varchar(255) NOT NULL default '',
  `mc_amount2` varchar(255) NOT NULL default '',
  `mc_amount3` varchar(255) NOT NULL default '',
  `recurring` varchar(255) NOT NULL default '',
  `reattempt` varchar(255) NOT NULL default '',
  `retry_at` varchar(255) NOT NULL default '',
  `recur_times` varchar(255) NOT NULL default '',
  `username` varchar(255) NOT NULL default '',
  `password` varchar(255) default NULL,
  `payment_txn_id` varchar(50) NOT NULL default '',
  `subscriber_emailaddress` varchar(255) NOT NULL default '',
  `datecreation` date NOT NULL default '0000-00-00'
)";
			require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
			echo($sql);
			dbDelta($sql);
			
			update_option($this->prefix."_db_version", "3.0");
		}
	}
}
?>